
local function safeNil(x)
	if (x ~= nil) then
		return x
	else
		return ""
	end

end

local function CHAT_MSG_ADDON(prefix, message, distribution, sender)
	
	if prefix == "FOLLOWMEBLIND" then
		--print(message .. " " .. sender)
		local name, realm = strsplit("-",sender)
		local arg1, arg2, arg3 = strsplit(" ", message)
		arg1 = safeNil(arg1)
		arg2 = safeNil(arg2)
		arg3 = safeNil(arg3)
		--print(arg1 .. "," .. arg2 .. "," .. arg3)
		if (arg1 == "blind") then
			if arg2 ~= "player" then
				FollowUnit(name)
				print("Blindly Following " .. name)
			else
				FollowUnit("player")
				print("Stopped Following")
			end
		else
			if arg1 ~= "player" then
				if CheckInteractDistance(name, 4) then
					FollowUnit(name)
					print("Following " .. name)
				else
					SendChatMessage("FollowMeBlind: You are out of Range!", "WHISPER", nil, name);
				end
			else
				FollowUnit("player")
				print("Stopped Following")
			end
		end
	end
end
C_ChatInfo.RegisterAddonMessagePrefix("FOLLOWMEBLIND")
local SendAddonMessage = C_ChatInfo.SendAddonMessage
local gfm = CreateFrame"Frame"
gfm:RegisterEvent"CHAT_MSG_ADDON"
gfm:SetScript("OnEvent",function(self, event, ...)
if event == "CHAT_MSG_ADDON" then
prefix, message, distribution, sender = ...
CHAT_MSG_ADDON(prefix, message, distribution, sender)
end

end)


local function OnUpdate(self)
    self:SetScript("OnUpdate",nil);
end

SlashCmdList["FOLLOWMEBLIND"] = function(arg)
	local chan = "PARTY"
	local arg1, arg2, arg3 = strsplit(" ", arg)
	arg1 = safeNil(arg1)
	arg2 = safeNil(arg2)
	arg3 = safeNil(arg3)
	--print(arg1 .. "," .. arg2 .. "," .. arg3)
	if arg1 == "blind" then
		if arg2 == "follow" then
			SendAddonMessage("FOLLOWMEBLIND", arg1 .. " " .. UnitName("player"), "WHISPER", arg3)
		elseif arg2 == "stay" then
			SendAddonMessage("FOLLOWMEBLIND", arg1 .. " " .. "player", "WHISPER", arg3)
		end
	else
		if  UnitInRaid("player") then
			chan = "RAID"
		end
		if arg == "follow" then
			SendAddonMessage("FOLLOWMEBLIND", UnitName("player"), chan, nil)
		elseif arg == "stay" then
			SendAddonMessage("FOLLOWMEBLIND", "player", chan, nil)
		end
	end
end
SLASH_FOLLOWMEBLIND1 = "/fm"